<template>
  <tr
    class="g-row"
    :class="{ 'clickable': clickable, 'selected': selected, 'focus': menuIsOpen }"
    style="user-select: none;"
    :style="{ 'background-color': backgroundColor }"
    @click.exact="onClick"
    @click.ctrl="internalSelected = !internalSelected">
    <td class="mobile-only">
      <div style="display: flex;">
        <div class="icon-container">
          <slot name="icon" />
        </div>
        <div style="flex-grow: 1; display: flex; flex-direction: column; justify-content: center; margin: 0 10px; overflow: hidden; text-overflow: ellipsis;">
          <slot name="title" />
        </div>
        <slot name="toolButtons" />
        <input
          v-if="selectable" 
          v-model="internalSelected"
          type="checkbox"
          style="cursor: pointer; width: 30px; height: 30px;"
          @click.stop
          @touchstart.stop
          @touchmove.stop
          @touchend.stop>
      </div>
    </td>

    <td v-if="selectable" class="desktop-only" @click.stop>
      <input v-model="internalSelected" type="checkbox" style="cursor: pointer;">
    </td>

    <td v-if="$slots.icon" class="desktop-only icon-container">
      <slot name="icon" />
    </td>

    <td class="desktop-only">
      <slot name="title" />
    </td>

    <slot />

    <td v-if="$slots.toolButtons" class="tool-buttons-container desktop-only">
      <div style="display: flex;">
        <slot name="toolButtons" />
      </div>
    </td>
  </tr>
</template>

<script>

import GMobileMenuDropdown from "./GMobileMenuDropdown.vue";

export default {
  name: "GBaseRow",
  components: {
    GMobileMenuDropdown,
  },
  props: {
    clickable: {
      type: Boolean,
      required: false,
      default: false,
    },
    selectable: {
      type: Boolean,
      required: false,
      default: false,
    },
    selected: {
      type: Boolean,
      required: false,
      default: false,
    },
    backgroundColor: {
      type: String,
      required: false,
      default: null,
    }
  },
  emits: ["click", "select", "refresh"],
  data() {
    return {
      internalSelected: false,
      menuIsOpen: false,
    };
  },
  watch: {
    selected(newVal) {
      this.internalSelected = newVal;
    },
    internalSelected(newVal) {
      this.$emit("select", newVal);
    },
  },
  methods: {
    onClick() {
      if (this.clickable) {
        this.$emit("click");
      }
    },
  },
};
</script>

<style lang="scss" scoped>

  .g-row { // Should be on tr element

    // td and th size and layout

    :deep(td),
    :deep(th) {
      padding: 10px;
      width: auto;
    }

    @media(max-width: 700px) {

      :deep(td) {
        padding: 0 5px 10px 5px;
        display: block; // Display cells in a column layout on mobile

        &:first-of-type {
          padding-top: 10px;
        }

        &:empty {
          padding: 0px;
        }
      }

      :deep(th) {
        display: none;
      }
      
    }

    // Make every 2n rows more gray

    &:nth-of-type(2n) {
      background: rgb(230, 230, 230);
    }

    // Selectable row : Add effect on hover or focus or selected

    &.clickable {
      cursor: pointer;
      transition: 0.1s;

      &:hover {
        background: lighten($primary, 20%);
      }
    }

    &.focus {
      background: lightblue;
    }

    &.selected {
      background: lightgreen !important;

      &:nth-of-type(2n) {
        background: rgb(84, 235, 84) !important;
      }
    }

    .icon-container {
      font-size: 2rem;
    }

    .tool-buttons-container {
      width: min-content;
    }

  }

  

</style>